
	section .text
	align  1

	global _ihypot

_ihypot           ; word ihypot(word a_in_E, word b_in_D);

	tste
	beq  L3       ; a was 0, result is b already in D
	xgde          ; exchange a and b, no effect on result
	tste
	beq  L3       ; b was 0, result is a now in D

	xgdx          ; save b
	ted           ; E and D both have a
	emul          ; ED = a * a
	pshm e,d      ; intermediate result (a^2) into stack (E at top)

	xgdx          ; restore b
	tde           ; E and D both have b
	emul          ; ED has (b^2)

	tsx           ; X now free to point to locals
	addd 2,x
	adce 0,x      ; ED has a^2 + b^2
	ais  #+4      ; purge temporaries
	bcc  _isqrt   ; continue to square root if no overflow (return to caller)

	ldd #0FFFFh   ; did overflow, return max possible
L3
	rts

	;
	;  accurate result to about 40k, beyond that accurate enough
	;

	global _isqrt

_isqrt            ; word isqrt(unsigned long ED)

	pshm e,d      ; pshm fixed order: D goes first
	ais  #-6      ; space for 3 additional locals
	tsx           ; a 0,x  i 2,x  r 4,x  E 6,x,  D 8,x

	ldd  #16
	std  2,x      ; i = 16
	clrw 4,x      ; r = 0
	clrw 0,x      ; a = 0
L1
	aslw 8,x
	rolw 6,x
	rolw 4,x
	aslw 8,x
	rolw 6,x
	rolw 4,x      ; r <<= 2; r += TOP2BITS(x); x <<= 2;

	aslw 0,x      ; a <<= 1;
	ldd  0,x
	asld
	addd #1       ; e = (a << 1) | 1;

	lde  4,x
	sde
	bcs  L2       ; if (r >= e) {
	ste  4,x      ;     r -= e;
	incw 0,x      ;     ++a;    }
L2
	decw 2,x
	bne  L1       ; loop i times, 16 that is

	pulm d        ; return a
	ais  #+8      ; purge other locals
	rts

	end

